# Index – Symbols

- ! (exclamation)
  - in a command interpreter
  - in curses module
  - in formatted string literal
  - in glob-style wildcards, [1]
  - in string formatting
  - in struct format strings
- ! (pdb command)
- !=
  - operator, [1]
- " (double quote)
  - string literal
- """
  - string literal
- # (hash)
  - comment, [1], [2]
  - in doctests
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - source encoding declaration
- $ (dollar)
  - environment variables expansion
  - in regular expressions
  - in template strings
  - interpolation in configuration files
- % (percent)
  - datetime format, [1], [2]
  - environment variables expansion (Windows), [1]
  - interpolation in configuration files
  - operator, [1]
  - printf-style formatting, [1]
- %=
  - augmented assignment
- & (ampersand)
  - operator, [1]
- &=
  - augmented assignment
- ' (single quote)
  - string literal
- '''
  - string literal
- () (parentheses)
  - call
  - class definition
  - function definition
  - generator expression
  - in assignment target list
  - in printf-style formatting, [1]
  - in regular expressions
  - tuple display
- (?
  - in regular expressions
- (?!
  - in regular expressions
- (?#
  - in regular expressions
- (?:
  - in regular expressions
- (?<!
  - in regular expressions
- (?<=
  - in regular expressions
- (?=
  - in regular expressions
- (?P<
  - in regular expressions
- (?P=
  - in regular expressions
- * (asterisk)
  - function definition
  - import statement
  - in AST grammar
  - in argparse module
  - in assignment target list
  - in expression lists
  - in function calls, [1]
  - in glob-style wildcards, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - operator, [1]
- **
  - function definition
  - in dictionary displays
  - in function calls, [1]
  - in glob-style wildcards
  - operator, [1]
- **=
  - augmented assignment
- *=
  - augmented assignment
- *?
  - in regular expressions
- + (plus)
  - binary operator, [1]
  - in argparse module
  - in doctests
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - unary operator, [1]
- +=
  - augmented assignment
- +?
  - in regular expressions
- , (comma)
  - argument list
  - expression list, [1], [2], [3], [4]
  - identifier list, [1]
  - import statement
  - in dictionary displays
  - in string formatting
  - in target list
  - parameter list
  - slicing
  - with statement
- - (minus)
  - binary operator, [1]
  - in doctests
  - in glob-style wildcards, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - unary operator, [1]
- --check-hash-based-pycs default|always|never
  - command line option
- --create <tarfile> <source1> ... <sourceN>
  - tarfile command line option
- --create <zipfile> <source1> ... <sourceN>
  - zipfile command line option
- --details
  - inspect command line option
- --extract <tarfile> [<output_dir>]
  - tarfile command line option
- --extract <zipfile> <output_dir>
  - zipfile command line option
- --help
  - command line option
  - trace command line option
- --ignore-dir=<dir>
  - trace command line option
- --ignore-module=<mod>
  - trace command line option
- --info
  - zipapp command line option
- --invalidation-mode [timestamp|checked-hash|unchecked-hash]
  - compileall command line option
- --list <tarfile>
  - tarfile command line option
- --list <zipfile>
  - zipfile command line option
- --locals
  - unittest command line option
- --sort-keys
  - json.tool command line option
- --test <tarfile>
  - tarfile command line option
- --test <zipfile>
  - zipfile command line option
- --user-base
  - site command line option
- --user-site
  - site command line option
- --version
  - command line option
  - trace command line option
- -=
  - augmented assignment
- ->
  - function annotations, [1]
- -?
  - command line option
- -a, --annotate
  - pickletools command line option
- -B
  - command line option
- -b
  - command line option
  - compileall command line option
- -b, --buffer
  - unittest command line option
- -c <command>
  - command line option
- -c <tarfile> <source1> ... <sourceN>
  - tarfile command line option
- -c <zipfile> <source1> ... <sourceN>
  - zipfile command line option
- -c, --catch
  - unittest command line option
- -c, --compress
  - zipapp command line option
- -c, --count
  - trace command line option
- -C, --coverdir=<dir>
  - trace command line option
- -d
  - command line option
- -d destdir
  - compileall command line option
- -E
  - command line option
- -e <tarfile> [<output_dir>]
  - tarfile command line option
- -e <zipfile> <output_dir>
  - zipfile command line option
- -e, --exact
  - tokenize command line option
- -f
  - compileall command line option
- -f, --failfast
  - unittest command line option
- -f, --file=<file>
  - trace command line option
- -g, --timing
  - trace command line option
- -h
  - command line option
- -h, --help
  - json.tool command line option
  - timeit command line option
  - tokenize command line option
  - zipapp command line option
- -I
  - command line option
- -i
  - command line option
- -i list
  - compileall command line option
- -J
  - command line option
- -j N
  - compileall command line option
- -k
  - unittest command line option
- -l
  - compileall command line option
- -l <tarfile>
  - tarfile command line option
- -l <zipfile>
  - zipfile command line option
- -l, --indentlevel=<num>
  - pickletools command line option
- -l, --listfuncs
  - trace command line option
- -m <mainfn>, --main=<mainfn>
  - zipapp command line option
- -m <module-name>
  - command line option
- -m, --memo
  - pickletools command line option
- -m, --missing
  - trace command line option

- -n N, --number=N
  - timeit command line option
- -O
  - command line option
- -o <output>, --output=<output>
  - zipapp command line option
- -o, --output=<file>
  - pickletools command line option
- -OO
  - command line option
- -p <interpreter>, --python=<interpreter>
  - zipapp command line option
- -p, --pattern pattern
  - unittest-discover command line option
- -p, --preamble=<preamble>
  - pickletools command line option
- -p, --process
  - timeit command line option
- -q
  - command line option
  - compileall command line option
- -R
  - command line option
- -r
  - compileall command line option
- -r N, --repeat=N
  - timeit command line option
- -R, --no-report
  - trace command line option
- -r, --report
  - trace command line option
- -S
  - command line option
- -s
  - command line option
- -s S, --setup=S
  - timeit command line option
- -s, --start-directory directory
  - unittest-discover command line option
- -s, --summary
  - trace command line option
- -t <tarfile>
  - tarfile command line option
- -t <zipfile>
  - zipfile command line option
- -t, --top-level-directory directory
  - unittest-discover command line option
- -t, --trace
  - trace command line option
- -T, --trackcalls
  - trace command line option
- -u
  - command line option
- -u, --unit=U
  - timeit command line option
- -V
  - command line option
- -v
  - command line option
- -v, --verbose
  - tarfile command line option
  - timeit command line option
  - unittest-discover command line option
- -W arg
  - command line option
- -X
  - command line option
- -x
  - command line option
- -x regex
  - compileall command line option
- . (dot)
  - attribute reference
  - in Tkinter
  - in glob-style wildcards
  - in numeric literal
  - in pathnames, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
- ..
  - in pathnames
- ...
  - ellipsis literal, [1], [2]
  - in doctests
  - interpreter prompt, [1]
  - placeholder, [1], [2]
- .ini
  - file
- .pdbrc
  - file
- / (slash)
  - in pathnames, [1]
  - operator, [1]
- //
  - operator, [1]
- //=
  - augmented assignment
- /=
  - augmented assignment
- 0b
  - integer literal
- 0o
  - integer literal
- 0x
  - integer literal
- 2to3
- : (colon)
  - annotated variable
  - compound statement, [1], [2], [3], [4], [5], [6]
  - function annotations, [1]
  - in SQL statements
  - in dictionary expressions
  - in formatted string literal
  - in string formatting
  - lambda expression
  - path separator (POSIX)
  - slicing
- ; (semicolon), [1]
- < (less)
  - in string formatting
  - in struct format strings
  - operator, [1]
- <<
  - operator, [1]
- <<=
  - augmented assignment
- <=
  - operator, [1]
- <BLANKLINE>
- = (equals)
  - assignment statement
  - class definition
  - function definition
  - in function calls
  - in string formatting
  - in struct format strings
- ==
  - operator, [1]
- > (greater)
  - in string formatting
  - in struct format strings
  - operator, [1]
- >=
  - operator, [1]
- >>
  - operator, [1]
- >>=
  - augmented assignment
- >>>
  - interpreter prompt, [1]
- ? (question mark)
  - in AST grammar
  - in SQL statements
  - in a command interpreter
  - in argparse module
  - in glob-style wildcards, [1]
  - in regular expressions
  - in struct format strings, [1]
  - replacement character
- ??
  - in regular expressions
- @ (at)
  - class definition
  - function definition
  - in struct format strings
  - operator
- [] (square brackets)
  - in assignment target list
  - in glob-style wildcards, [1]
  - in regular expressions
  - in string formatting
  - list expression
  - subscription
- \ (backslash)
  - escape sequence, [1]
  - in pathnames (Windows)
  - in regular expressions, [1], [2]
- \\
  - escape sequence
  - in regular expressions
- \A
  - in regular expressions
- \a
  - escape sequence
  - in regular expressions
- \B
  - in regular expressions
- \b
  - escape sequence
  - in regular expressions, [1]
- \D
  - in regular expressions
- \d
  - in regular expressions
- \f
  - escape sequence
  - in regular expressions
- \g
  - in regular expressions
- \N
  - escape sequence, [1]
  - in regular expressions
- \n
  - escape sequence
  - in regular expressions
- \r
  - escape sequence
  - in regular expressions
- \S
  - in regular expressions
- \s
  - in regular expressions
- \t
  - escape sequence
  - in regular expressions
- \U
  - escape sequence, [1]
  - in regular expressions
- \u
  - escape sequence, [1]
  - in regular expressions
- \v
  - escape sequence
  - in regular expressions
- \W
  - in regular expressions
- \w
  - in regular expressions
- \x
  - escape sequence, [1]
  - in regular expressions
- \Z
  - in regular expressions
- ^ (caret)
  - in curses module
  - in regular expressions, [1]
  - in string formatting
  - marker, [1]
  - operator, [1]
- ^=
  - augmented assignment
- {} (curly brackets)
  - dictionary expression
  - in formatted string literal
  - in regular expressions
  - in string formatting
  - set expression
- | (vertical bar)
  - in regular expressions
  - operator, [1]
- |=
  - augmented assignment
- ~ (tilde)
  - home directory expansion
  - operator, [1]